#include "androidarchiver.h"
#include "androidtools.h"

AndroidArchiver::AndroidArchiver(Builder &b, const Architecture &a, const AndroidNdk &ndk):
	CustomizedTool(b, "AR", a)
{
	set_command("ar", true);
	if(ndk.get_root_dir().empty())
		problems.push_back("Android NDK not found");
	else if(ndk.get_bin_dir().empty())
		problems.push_back("Android NDK toolchain not found");
	else
		set_command((ndk.get_bin_dir()/command).str());
}
