#include "androidlinker.h"
#include "androidtools.h"

using namespace std;

AndroidLinker::AndroidLinker(Builder &b, const Architecture &a, const AndroidNdk &ndk):
	CustomizedTool(b, "LINK", a)
{
	set_command("gcc", true);
	if(ndk.get_root_dir().empty())
		problems.push_back("Android NDK not found");
	else if(ndk.get_bin_dir().empty())
		problems.push_back("Android NDK toolchain not found");
	else
		set_command((ndk.get_bin_dir()/command).str());

	build_info.sysroot = ndk.get_platform_sysroot();
}

Target *AndroidLinker::create_target(const vector<Target *> &sources, const string &)
{
	return CustomizedTool::create_target(sources, "shared");
}
