#include <msp/builder/builder.h>
#include <msp/builder/sourcepackage.h>
#include <msp/core/algorithm.h>
#include "androidapplicationcomponent.h"
#include "androidmanifestfile.h"

using namespace std;
using namespace Msp;

AndroidManifestFile::AndroidManifestFile(Builder &b, const AndroidApplicationComponent &a):
	FileTarget(b, a.get_package(), a.get_package().get_temp_directory()/a.get_name()/"AndroidManifest.xml")
{
	component = &a;
	tool = &builder.get_toolchain().get_tool("AMG");

	add_dependency(package->get_build_file());
}

void AndroidManifestFile::set_native_library(SharedLibrary *lib)
{
	native_lib = lib;
}

void AndroidManifestFile::set_orientation(const string &ori)
{
	orientation = ori;
}

void AndroidManifestFile::add_permission(const string &perm)
{
	if(!any_equals(permissions, perm))
		permissions.push_back(perm);
}
