#ifndef ANDROIDMANIFESTFILE_H_
#define ANDROIDMANIFESTFILE_H_

#include <vector>
#include <msp/builder/filetarget.h>

class AndroidApplicationComponent;
class SharedLibrary;

/**
Metadata file for an Android application.
*/
class AndroidManifestFile: public FileTarget
{
private:
	SharedLibrary *native_lib = 0;
	std::vector<std::string> permissions;
	std::string orientation;

public:
	AndroidManifestFile(Builder &, const AndroidApplicationComponent &);

	const char *get_type() const override { return "AndroidManifestFile"; }

	void set_native_library(SharedLibrary *);
	SharedLibrary *get_native_library() const { return native_lib; }

	void add_permission(const std::string &);
	void set_orientation(const std::string &);
	const std::vector<std::string> &get_permissions() const { return permissions; }
	const std::string &get_orientation() const { return orientation; }
};

#endif
