#include <msp/builder/architecture.h>
#include <msp/builder/builder.h>
#include "androidapplicationcomponent.h"
#include "androidplugin.h"
#include "androidtools.h"

AndroidPlugin::AndroidPlugin(Builder &b):
	Plugin(b)
{
	required_plugins.push_back("gnutools");
	builder.get_component_registry().register_type<AndroidApplicationComponent>("android_application");
}

void AndroidPlugin::add_tools(Toolchain &toolchain, const Architecture &arch) const
{
	if(arch.get_system()=="android")
		toolchain.add_toolchain(new AndroidTools(builder, arch));
}


#ifdef ANDROIDTOOLS_BUILD
#if defined(_WIN32)
#define ANDROIDTOOLS_API __declspec(dllexport)
#elif defined(__GNUC__)
#define ANDROIDTOOLS_API __attribute__((visibility("default")))
#else
#define ANDROIDTOOLS_API
#endif

extern "C"
ANDROIDTOOLS_API Plugin *create_plugin(Builder &builder)
{
	return new AndroidPlugin(builder);
}
#endif
