#include <msp/builder/component.h>
#include <msp/fs/utils.h>
#include "androidresourcefile.h"

using namespace std;
using namespace Msp;

AndroidResourceFile::AndroidResourceFile(Builder &b, const Component &c, const FS::Path &p):
	FileTarget(b, c.get_package(), p)
{
	string ext = FS::extpart(FS::basename(p));
	if(ext==".png" || ext==".jpg")
		resource_type = "drawable";
	// TODO recognize various xml files; must inspect contents
	else
		resource_type = "raw";

	install_location = "res/"+resource_type;
}
