#include <msp/builder/component.h>
#include <msp/builder/filetarget.h>
#include <msp/builder/sourcepackage.h>
#include <msp/core/environ.h>
#include <msp/fs/utils.h>
#include "jarsigner.h"

using namespace std;
using namespace Msp;

JarSigner::JarSigner(Builder &b):
	Tool(b, "JSGN")
{
	set_command("jarsigner");
	set_run_external(_run);
}

Target *JarSigner::create_target(const vector<Target *> &, const string &)
{
	throw logic_error("not implemented");
}

ExternalTask::Arguments JarSigner::_run(const FileTarget &file, FS::Path &work_dir)
{
	const Tool &tool = *file.get_tool();

	ExternalTask::Arguments argv;
	argv.push_back(tool.get_executable()->get_path().str());

	// TODO Make this generic
	FS::Path home_dir = Msp::getenv("HOME");
	argv.push_back("-keystore");
	argv.push_back((home_dir/".android"/"debug.keystore").str());
	argv.push_back("-storepass");
	argv.push_back("android");

	argv.push_back(FS::relative(file.get_path(), work_dir).str());
	argv.push_back("androiddebugkey");

	return argv;
}
