#include <msp/builder/builder.h>
#include <msp/builder/tool.h>
#include "baseplugin.h"
#include "basetools.h"
#include "compilecommandsjson.h"
#include "pkgconfigfile.h"

void BasePlugin::add_tools(Toolchain &toolchain, const Architecture &) const
{
	toolchain.add_toolchain(new BaseTools(builder));
}

void BasePlugin::create_targets(SourcePackage &spkg) const
{
	const Architecture &native_arch = builder.get_native_arch();

	if(!spkg.get_exported_build_info().libs.empty() && native_arch.get_system()=="linux")
	{
		PkgConfigFile *pc = new PkgConfigFile(builder, spkg);
		builder.get_build_graph().get_target("install")->add_dependency(*builder.get_toolchain().get_tool("CP").create_target(*pc));
	}

	new CompileCommandsJson(builder, spkg);
}


#ifdef BASETOOLS_BUILD
#if defined(_WIN32)
#define BASETOOLS_API __declspec(dllexport)
#elif defined(__GNUC__)
#define BASETOOLS_API __attribute__((visibility("default")))
#else
#define BASETOOLS_API
#endif

extern "C"
BASETOOLS_API Plugin *create_plugin(Builder &builder)
{
	return new BasePlugin(builder);
}
#endif
