#include <msp/builder/builder.h>
#include <msp/fs/stat.h>
#include "clanglinker.h"

using namespace Msp;

ClangLinker::ClangLinker(Builder &b, const Architecture &a):
	CustomizedTool(b, "LINK", a)
{
	set_command("clang", true);
}

void ClangLinker::do_prepare(ToolData &tool) const
{
	parent.prepare();
	CustomizedTool::do_prepare(tool);
	for(const FS::Path &p: parent.get_system_path())
		if(FS::exists(p/"libstdc++.so"))
		{
			builder.get_logger().log("tools", "Got %s gcc system path: %s", static_cast<const Tool &>(tool).get_tag(), p);
			tool.system_path.push_back(p);
			break;
		}
}
