#include "clangplugin.h"
#include "clangtools.h"

ClangPlugin::ClangPlugin(Builder &b):
	Plugin(b)
{
	required_plugins.push_back("gnutools");
}

void ClangPlugin::add_tools(Toolchain &toolchain, const Architecture &arch) const
{
	toolchain.add_toolchain(new ClangTools(builder, arch));
}


#ifdef CLANGTOOLS_BUILD
#if defined(_WIN32)
#define CLANGTOOLS_API __declspec(dllexport)
#elif defined(__GNUC__)
#define CLANGTOOLS_API __attribute__((visibility("default")))
#else
#define CLANGTOOLS_API
#endif

extern "C"
CLANGTOOLS_API Plugin *create_plugin(Builder &builder)
{
	return new ClangPlugin(builder);
}
#endif
