#include <msp/builder/architecture.h>
#include "clangcompiler.h"
#include "clanglinker.h"
#include "clangtools.h"

using namespace std;

ClangTools::ClangTools(Builder &builder, const Architecture &arch):
	Toolchain("clang", get_priority(arch))
{
	add_tool(new ClangCompiler(builder, arch, "CC"));
	add_tool(new ClangCompiler(builder, arch, "CXX"));
	add_tool(new ClangCompiler(builder, arch, "OBJC"));

	add_tool(new ClangLinker(builder, arch));
}

int ClangTools::get_priority(const Architecture &arch)
{
	if(arch.get_toolchain()=="clang")
		return 20;
	else if(arch.get_system()=="darwin" || arch.get_system()=="freebsd")
		return 10;
	else
		return 0;
}
