#include <msp/builder/component.h>
#include <msp/builder/sourcepackage.h>
#include <msp/fs/utils.h>
#include "datacollection.h"
#include "datatransform.h"

using namespace Msp;

DataCollection::DataCollection(Builder &b, const Component &c, DataTransform &s):
	FileTarget(b, c.get_package(), generate_target_path(c, s.get_path())),
	source(s)
{
	component = &c;
	add_dependency(source);
}

Msp::FS::Path DataCollection::generate_target_path(const Component &comp, const Msp::FS::Path &src)
{
	return comp.get_package().get_temp_directory()/comp.get_name()/(FS::basepart(FS::basename(src))+".mdc");
}
