#include <msp/builder/builder.h>
#include "datafileplugin.h"
#include "datapackcomponent.h"
#include "datatool.h"

DataFilePlugin::DataFilePlugin(Builder &b):
	Plugin(b)
{
	builder.get_component_registry().register_type<DataPackComponent>("datapack");
}

void DataFilePlugin::add_tools(Toolchain &toolchain, const Architecture &) const
{
	toolchain.add_tool(new DataTool(builder));
}


#ifdef DATATOOLS_BUILD
#if defined(_WIN32)
#define DATATOOLS_API __declspec(dllexport)
#elif defined(__GNUC__)
#define DATATOOLS_API __attribute__((visibility("default")))
#else
#define DATATOOLS_API
#endif

extern "C"
DATATOOLS_API Plugin *create_plugin(Builder &builder)
{
	return new DataFilePlugin(builder);
}
#endif
