#include <msp/builder/component.h>
#include <msp/builder/sourcepackage.h>
#include "datapack.h"

using namespace std;

DataPack::DataPack(Builder &b, const Component &c, const vector<FileTarget *> &f):
	FileTarget(b, c.get_package(), generate_target_path(c)),
	files(f)
{
	component = &c;
	for(FileTarget *t: files)
		add_dependency(*t);

	install_location = Msp::FS::Path("share")/package->get_name();
}

Msp::FS::Path DataPack::generate_target_path(const Component &comp)
{
	return comp.get_package().get_output_directory()/(comp.get_name()+".mdp");
}
