#ifndef DATAPACK_H_
#define DATAPACK_H_

#include <msp/builder/filetarget.h>

class DataPack: public FileTarget
{
private:
	std::vector<FileTarget *> files;

public:
	DataPack(Builder &, const Component &, const std::vector<FileTarget *> &);
private:
	static Msp::FS::Path generate_target_path(const Component &);

public:
	const char *get_type() const override { return "DataPack"; }

	const std::vector<FileTarget *> &get_files() const { return files; }
};

#endif
