#ifndef GNUCOMPILER_H_
#define GNUCOMPILER_H_

#include <msp/builder/tool.h>

class ObjectFile;

/**
The GNU compiler.  Can be created with different tags for different languages.
Turns SourceFiles into ObjectFiles.
*/
class GnuCompiler: public Tool
{
public:
	GnuCompiler(Builder &, const Architecture &, const std::string &);

	Target *create_source(const Component &, const Msp::FS::Path &) const override;
	Target *create_source(const Msp::FS::Path &) const override;
	Target *create_target(const std::vector<Target *> &, const std::string &) override;
	std::string create_build_signature(const BuildInfo &) const override;
protected:
	void do_prepare(ToolData &) const override;
	void prepare_syspath(ToolData &) const;
	void prepare_version(ToolData &) const;
	unsigned query_version(const std::string &, const std::string &) const;

private:
	static ExternalTask::Arguments _run(const ObjectFile &, Msp::FS::Path &);
};

#endif
