#ifndef GNULINKER_H_
#define GNULINKER_H_

#include <msp/builder/tool.h>

class Binary;

/**
The GNU linker.  Turns ObjectFiles into Executables and SharedLibraries.  To
create a shared library, specify "shared" as the second argument to
create_target.
*/
class GnuLinker: public Tool
{
public:
	GnuLinker(Builder &, const Architecture &);

	Target *create_target(const std::vector<Target *> &, const std::string &) override;
	Target *create_install(Target &) const override;
	std::string create_build_signature(const BuildInfo &) const override;
protected:
	void do_prepare(ToolData &) const override;
private:
	static ExternalTask::Arguments _run(const Binary &, Msp::FS::Path &);
};

#endif
