#ifndef MICROSOFTTOOLS_H_
#define MICROSOFTTOOLS_H_

#include <msp/builder/toolchain.h>
#include <msp/fs/path.h>

class Architecture;
class Builder;

class MicrosoftTools: public Toolchain
{
private:
	Msp::FS::Path vc_base_dir;
	Msp::FS::Path vc_bin_dir;
	Msp::FS::Path win_sdk_dir;
	std::string win_sdk_version;

public:
	MicrosoftTools(Builder &, const Architecture &);

private:
	void find_vc_bin_dir(Builder &, const Architecture &);
	void find_windows_sdk_dir(Builder &);

public:
	const Msp::FS::Path &get_vc_base_dir() const { return vc_base_dir; }
	const Msp::FS::Path &get_vc_bin_dir() const { return vc_bin_dir; }
	const Msp::FS::Path &get_windows_sdk_dir() const { return win_sdk_dir; }
	const std::string &get_windows_sdk_version() const { return win_sdk_version; }

	static int get_priority(const Architecture &);
};

#endif
