#ifndef MSVCCOMPILER_H_
#define MSVCCOMPILER_H_

#include <msp/builder/tool.h>

class MicrosoftTools;
class ObjectFile;

class MsvcCompiler: public Tool
{
private:
	const MicrosoftTools &ms_tools;

public:
	MsvcCompiler(Builder &, const Architecture &, const std::string &, const MicrosoftTools &);

	Target *create_source(const Component &, const Msp::FS::Path &) const override;
	Target *create_source(const Msp::FS::Path &) const override;
	Target *create_target(const std::vector<Target *> &, const std::string &) override;
	std::string create_build_signature(const BuildInfo &) const override;

protected:
	void do_prepare(ToolData &) const override;

public:
	static ExternalTask::Arguments _run(const ObjectFile &, Msp::FS::Path &);
};

#endif
