#ifndef BOOLEANEVALUATOR_H_
#define BOOLEANEVALUATOR_H_

#include <functional>
#include <string>
#include <vector>

class BooleanEvaluator
{
public:
	using ValueFunction = std::function<bool(const std::string &)>;
	using CompareFunction = std::function<bool(const std::string &, const std::string *)>;

private:
	CompareFunction func;
	std::string ops;
	std::vector<std::string> var_stack;
	std::vector<unsigned char> value_stack;
	std::vector<char> op_stack;
	bool last_was_op;

public:
	BooleanEvaluator(const ValueFunction &);
	BooleanEvaluator(const CompareFunction &);

	bool evaluate(const std::string &);
private:
	void push_op(char);
	bool pop_value();
	void collapse(unsigned);
	unsigned precedence(char);
	bool is_unary(char);
	bool is_logic(char);
};

#endif
