#ifndef CSOURCEFILE_H_
#define CSOURCEFILE_H_

#include <msp/io/base.h>
#include "libbuilder_api.h"
#include "sourcefile.h"

/**
Represents a C or C++ source file.
*/
class LIBBUILDER_API CSourceFile: public SourceFile
{
protected:
	std::vector<std::string> includes;

public:
	CSourceFile(Builder &b, const Msp::FS::Path &p): SourceFile(b, p) { }
	CSourceFile(Builder &, const Component &, const Msp::FS::Path &);

	const char *get_type() const override { return "CSourceFile"; }
	const std::vector<std::string> &get_includes() const { return includes; }
protected:
	virtual void parse_includes(Msp::IO::Base &);
	void find_dependencies() override;
	void modified() override;
};

#endif
