#ifndef CUSTOMIZEDTOOL_H_
#define CUSTOMIZEDTOOL_H_

#include "libbuilder_api.h"
#include "tool.h"

class LIBBUILDER_API CustomizedTool: public Tool
{
protected:
	Tool &parent;

	CustomizedTool(Builder &, const std::string &, const Architecture &);
	CustomizedTool(Tool &, const Architecture &);

public:
	const Tool *get_base_tool() const override { return &parent; }
	Target *create_source(const Component &, const Msp::FS::Path &) const override;
	Target *create_source(const Msp::FS::Path &) const override;
	Target *create_target(const std::vector<Target *> &, const std::string & = std::string()) override;
	Target *create_install(Target &) const override;
	std::string create_build_signature(const BuildInfo &) const override;
protected:
	void do_prepare(ToolData &) const override;
};

#endif
