#include "component.h"
#include "exportdefinitions.h"
#include "objectfile.h"
#include "sourcepackage.h"

using namespace std;
using namespace Msp;

ExportDefinitions::ExportDefinitions(Builder &b, const Component &c, const vector<ObjectFile *> &objs):
	FileTarget(b, c.get_package(), generate_target_path(c))
{
	component = &c;
	for(ObjectFile *o: objs)
		add_dependency(*o);
}

FS::Path ExportDefinitions::generate_target_path(const Component &comp)
{
	return comp.get_package().get_temp_directory()/comp.get_name()/(comp.get_name()+".def");
}
