#ifndef EXPORTDEFINITIONS_H_
#define EXPORTDEFINITIONS_H_

#include "filetarget.h"
#include "libbuilder_api.h"

class ObjectFile;

/**
An export definition file for a shared library.  Only used on Windows.
*/
class LIBBUILDER_API ExportDefinitions: public FileTarget
{
public:
	ExportDefinitions(Builder &, const Component &, const std::vector<ObjectFile *> &);
private:
	static Msp::FS::Path generate_target_path(const Component &);

public:
	const char *get_type() const override { return "ExportDefinitions"; }
};

#endif
