#ifndef IMPORTLIBRARY_H_
#define IMPORTLIBRARY_H_

#include "filetarget.h"
#include "libbuilder_api.h"

class ExportDefinitions;
class SharedLibrary;

/**
A special case of static library which pulls in a shared library.  Used on
platforms with no true dynamic linking support.
*/
class LIBBUILDER_API ImportLibrary: public FileTarget
{
private:
	SharedLibrary *shared_lib = 0;

public:
	ImportLibrary(Builder &b, const Msp::FS::Path &p): FileTarget(b, p) { }
	ImportLibrary(Builder &, const Component &, SharedLibrary &);
private:
	static std::string generate_filename(const Component &, const SharedLibrary &);

public:
	const char *get_type() const override { return "ImportLibrary"; }

	SharedLibrary *get_shared_library() const { return shared_lib; }
};

#endif
