#include "installcomponent.h"
#include "builder.h"
#include "file.h"
#include "sourcepackage.h"
#include "tool.h"

using namespace std;
using namespace Msp;

void InstallComponent::create_targets() const
{
	Builder &builder = package.get_builder();
	Target *inst = builder.get_build_graph().get_target("install");
	Tool &copy = builder.get_toolchain().get_tool("CP");

	for(const FS::Path &s: collect_source_files())
	{
		Target *tgt = builder.get_vfs().get_target(s);
		if(!tgt)
			tgt = new File(builder, package, s);
		inst->add_dependency(*copy.create_target(*tgt, name));
	}
}
