#include <msp/time/utils.h>
#include "internaltask.h"

using namespace Msp;

InternalTask::~InternalTask()
{
	worker.join();
}

void InternalTask::start()
{
	prepare();
	worker.launch();
}

Task::Status InternalTask::check()
{
	Status result = worker.get_status();
	if(result!=RUNNING)
		finished(result==SUCCESS);
	return result;
}

Task::Status InternalTask::wait()
{
	Status result;
	while((result = check())==RUNNING)
		Time::sleep(10*Time::msec);
	return result;
}


void InternalTask::Worker::main()
{
	if(func())
		status = Task::SUCCESS;
	else
		status = Task::ERROR;
}
