#ifndef PLUGIN_H_
#define PLUGIN_H_

#include <string>
#include <vector>
#include "libbuilder_api.h"

class Architecture;
class Builder;
class SourcePackage;
class Toolchain;

class LIBBUILDER_API Plugin
{
protected:
	Builder &builder;
	std::vector<std::string> required_plugins;

	Plugin(Builder &b): builder(b) { }
public:
	virtual ~Plugin() = default;

	const std::vector<std::string> &get_required_plugins() const { return required_plugins; }

	virtual void add_tools(Toolchain &, const Architecture &) const { }
	virtual void create_targets(SourcePackage &) const { }
};

#endif
