#ifndef SOURCEGENERATOR_H_
#define SOURCEGENERATOR_H_

#include <msp/datafile/objectloader.h>
#include "conditionalloader.h"
#include "sourcepackage.h"
#include "tool.h"

class SourceFile;

class SourceGenerator: public Tool
{
public:
	class Loader: public Msp::DataFile::ObjectLoader<SourceGenerator>, public ConditionalLoader
	{
	public:
		Loader(SourceGenerator &);

	private:
		void argument(const std::string &);
		void arguments(const std::vector<std::string> &);
		void command(const std::string &);
		void in_suffix(const std::string &);
		void out_argument(const std::string &);
		void out_suffix(const std::string &);
	};

private:
	const SourcePackage &package;
	std::vector<std::string> out_suffixes;
	std::vector<std::string> arguments;
	std::string out_argument;

public:
	SourceGenerator(Builder &, const SourcePackage &, const std::string &);

	Target *create_source(const Component &, const Msp::FS::Path &) const override;
	Target *create_target(const std::vector<Target *> &, const std::string &) override;

private:
	static ExternalTask::Arguments _run(const SourceFile &, Msp::FS::Path &);
};

#endif
