#include <msp/core/algorithm.h>
#include <msp/fs/path.h>
#include <msp/fs/utils.h>
#include "builder.h"
#include "virtualtarget.h"

using namespace std;
using namespace Msp;

void VirtualTarget::check_rebuild()
{
	// Virtual targets are only rebuilt if their dependencies need rebuilding.
	auto i = find_if(depends, [](Target *d){ return d->needs_rebuild(); });
	if(i!=depends.end())
		mark_rebuild((*i)->get_name()+" needs rebuilding");
}

Task *VirtualTarget::build()
{
	state = UPTODATE;
	return 0;
}
